<?php
class Utility {
  public static function total($array, $index) {
    $total = 0;
    for ($i = 1; $i <= $index; ++$i) {
      $total += $array[$i];
    }
    return $total;
  }

  public static function delta($array, $i) {
    if($i==1) {
      return 0;
    }
    return $array[$i] - $array[$i-1];
  }

  public static function maxStat($array) {
    $max = 0;
    foreach ($array as $val) {
      $max = max($max,$val);
    }
    return $max;
  }

  public static function statTotal($array) {
    $total = 0;
    foreach ($array as $val) {
      $total += $val;
    }
    return $total;
  }

  public static function statXPTotal($array) {
    $statsArray = Stats::get();
    $total = 0;
    foreach ($array as $val) {
      $total += Utility::total($statsArray,$val-1);
    }
    return $total;
  }

  public static function hpspXPTotal($hpspval) {
    $hpspArray = HPSP::get();
    $total = 0;
    $total += Utility::total($hpspArray,$hpspval-1);
    return $total;
  }

  public static function levelXPTotal($lvl) {
    $levelsArray = Levels::get();
    return Utility::total($levelsArray,$lvl);
  }

  public static function totalXP($lvl, $array, $hpspArray) {
    return Utility::levelXPTotal($lvl) + Utility::statXPTotal($array) + Utility::hpspXPTotal($hpspArray['hp']) + Utility::hpspXPTotal($hpspArray['sp']);
  }

  public static function levelStats($lvl) {
    return (1+$lvl-max(0,$lvl-20))*6 + max(0,$lvl-20)*5 + max(0,$lvl-129)*70;
  }

  public static function availableStats($lvl, $array) {
    return Utility::levelStats($lvl) - Utility::statTotal($array);
  }

  public static function bnoteCost($lvl) {
    $cost = 5000 + (($lvl - 22) * 3500);
    $cost = min(max($cost,5000),300000);
    return $cost;
  }

  public static function rezCost($lvl) {
    $cost = ($lvl - max(0,$lvl-25))*200 + max(0,$lvl-25) * 2000;

    if ($lvl < 8) {
      $cost -= 200;
    }

    return $cost;
  }

  public static function deathRezXPLoss($array) {
    $statsArray = Stats::get();
    return min($statsArray[Utility::maxStat($array)-1],$statsArray[100]);
  }

  public static function statResetLoss($array) {
    $statsArray = Stats::get();
    return Utility::total($statsArray,Utility::maxStat($array)-1)/2;
  }

  public static function deathXPLoss($lvl, $array) {
    return min((Utility::levelXPTotal($lvl)*0.1),20000000) + Utility::deathRezXPLoss($array);
  }

  public static function hopXPLoss($lvl) {
    return Utility::levelXPTotal($lvl)/2;
  }

  public static function hopLevel($lvl) {
    $imin = 1;
    $imax = $lvl;
    $target = Utility::hopXPLoss($lvl);

    while ($imax >= $imin) {
      $imid = round(($imin + $imax)/2,0);
      $imidxp = Utility::levelXPTotal($imid);
      if ($imidxp < $target) {
        $imin = $imid + 1;
      } elseif ($imidxp > $target) {
        $imax = $imid - 1;
      } else {
        return $imid;
      }
    }
    return $imin - 1;
  }
}
?>
